# Before `make install' is performed this script should be runnable with
# `make test'. After `make install' it should work as `perl 1.t'
#########################

use Test::More qw(no_plan);
BEGIN { use_ok('Hash') };                                # see if it compiles
use Hash qw( ADD DELETE SEARCH FIRST NEXT COUNT RESET);  # import subs

ok( ADD($_),            "adding '$_'") for qw( one two three );
ok( COUNT()==3,         "count==3");
ok( DELETE('two'),      "delete 'two'");
ok( COUNT()==2,         "count==2");
ok( SEARCH('one'),      "SEARCH 'one'");
ok( ! SEARCH('beta'),   "! SEARCH 'beta'");
ok( RESET(),            "reset collection");
ok( COUNT()==0,         "count==0");
ok( ADD($_),            "adding '$_'") for qw( zeta gamma beta alpha );
ok( FIRST() eq 'alpha', "FIRST is alpha");
ok( NEXT()  eq 'beta',  "NEXT is beta");
ok( ADD('aard'),        "ADD aard");
ok( NEXT()  eq 'aard',  "NEXT is aard (traversal should reset)");
ok( NEXT()  eq 'alpha', "NEXT is alpha");

